import { INIT_PAYMENTS_JOURNALS, SELECT_JOURNAL } from '@/constants/actionTypes'
import { SET_JOURNALS, SET_LOADING_JOURNALS, SET_SELECTED_JOURNAL } from '@/constants/mutationTypes'

const initialState ={
    journals: null,
    loadingJournal: false,
    selectedJournal: null
}
const state = {
    journals: initialState.journals,
    loadingJournal: initialState.loadingJournal,
    selectedJournal: initialState.selectedJournal
}
const getters = {
    /**
     * [journals description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    journals(state) {
        return state.journals
    },
    /**
     * [loadingJournal description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    loadingJournal(state) {
        return state.loadingJournal
    },
    /**
     * [selectedJournal description]
     * @method selectedJournal
     * @param  {[type]}        state [description]
     * @return {[type]}              [description]
     */
    selectedJournal (state) {
        return state.selectedJournal
    }

}
const mutations = {
    /**
     * [journals description]
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_JOURNALS] (state, payload) {
        state.journals = payload
    },
    /**
     * [loadingJournal description]
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_LOADING_JOURNALS] (state, payload) {
        state.loadingJournal = !!payload
    },
    /**
     * [selectedJournal description]
     * @type {[type]}
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_SELECTED_JOURNAL] (state, payload) {
        state.selectedJournal = payload
    }

}

const actions = {
    /**
     * [INIT_PAYMENTS_JOURNALS]
     * @param {*} param0
     * @param {*} payload
     */
    [INIT_PAYMENTS_JOURNALS] ({ commit },payload ) {
        commit(SET_JOURNALS, payload)
        commit(SET_LOADING_JOURNALS, payload)
    },
    /**
     * [SELECT_JOURNAL]
     * @param {*} param0
     * @param {*} payload
     */
    [SELECT_JOURNAL] ({ commit },payload ) {
        commit(SET_SELECTED_JOURNAL, payload)
    }

}

export default {
    state,
    getters,
    mutations,
    actions
}
